/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/pluralsh/plural-operator/api/platform/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeLogFilters implements LogFilterInterface
type FakeLogFilters struct {
	Fake *FakePlatformV1alpha1
	ns   string
}

var logfiltersResource = schema.GroupVersionResource{Group: "platform.plural.sh", Version: "v1alpha1", Resource: "logfilters"}

var logfiltersKind = schema.GroupVersionKind{Group: "platform.plural.sh", Version: "v1alpha1", Kind: "LogFilter"}

// Get takes name of the logFilter, and returns the corresponding logFilter object, and an error if there is any.
func (c *FakeLogFilters) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.LogFilter, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(logfiltersResource, c.ns, name), &v1alpha1.LogFilter{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LogFilter), err
}

// List takes label and field selectors, and returns the list of LogFilters that match those selectors.
func (c *FakeLogFilters) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.LogFilterList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(logfiltersResource, logfiltersKind, c.ns, opts), &v1alpha1.LogFilterList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.LogFilterList{ListMeta: obj.(*v1alpha1.LogFilterList).ListMeta}
	for _, item := range obj.(*v1alpha1.LogFilterList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested logFilters.
func (c *FakeLogFilters) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(logfiltersResource, c.ns, opts))

}

// Create takes the representation of a logFilter and creates it.  Returns the server's representation of the logFilter, and an error, if there is any.
func (c *FakeLogFilters) Create(ctx context.Context, logFilter *v1alpha1.LogFilter, opts v1.CreateOptions) (result *v1alpha1.LogFilter, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(logfiltersResource, c.ns, logFilter), &v1alpha1.LogFilter{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LogFilter), err
}

// Update takes the representation of a logFilter and updates it. Returns the server's representation of the logFilter, and an error, if there is any.
func (c *FakeLogFilters) Update(ctx context.Context, logFilter *v1alpha1.LogFilter, opts v1.UpdateOptions) (result *v1alpha1.LogFilter, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(logfiltersResource, c.ns, logFilter), &v1alpha1.LogFilter{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LogFilter), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeLogFilters) UpdateStatus(ctx context.Context, logFilter *v1alpha1.LogFilter, opts v1.UpdateOptions) (*v1alpha1.LogFilter, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(logfiltersResource, "status", c.ns, logFilter), &v1alpha1.LogFilter{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LogFilter), err
}

// Delete takes name of the logFilter and deletes it. Returns an error if one occurs.
func (c *FakeLogFilters) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(logfiltersResource, c.ns, name), &v1alpha1.LogFilter{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeLogFilters) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(logfiltersResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.LogFilterList{})
	return err
}

// Patch applies the patch and returns the patched logFilter.
func (c *FakeLogFilters) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.LogFilter, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(logfiltersResource, c.ns, name, pt, data, subresources...), &v1alpha1.LogFilter{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LogFilter), err
}
