/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/pluralsh/plural-operator/api/platform/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeLogTails implements LogTailInterface
type FakeLogTails struct {
	Fake *FakePlatformV1alpha1
	ns   string
}

var logtailsResource = schema.GroupVersionResource{Group: "platform.plural.sh", Version: "v1alpha1", Resource: "logtails"}

var logtailsKind = schema.GroupVersionKind{Group: "platform.plural.sh", Version: "v1alpha1", Kind: "LogTail"}

// Get takes name of the logTail, and returns the corresponding logTail object, and an error if there is any.
func (c *FakeLogTails) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.LogTail, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(logtailsResource, c.ns, name), &v1alpha1.LogTail{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LogTail), err
}

// List takes label and field selectors, and returns the list of LogTails that match those selectors.
func (c *FakeLogTails) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.LogTailList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(logtailsResource, logtailsKind, c.ns, opts), &v1alpha1.LogTailList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.LogTailList{ListMeta: obj.(*v1alpha1.LogTailList).ListMeta}
	for _, item := range obj.(*v1alpha1.LogTailList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested logTails.
func (c *FakeLogTails) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(logtailsResource, c.ns, opts))

}

// Create takes the representation of a logTail and creates it.  Returns the server's representation of the logTail, and an error, if there is any.
func (c *FakeLogTails) Create(ctx context.Context, logTail *v1alpha1.LogTail, opts v1.CreateOptions) (result *v1alpha1.LogTail, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(logtailsResource, c.ns, logTail), &v1alpha1.LogTail{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LogTail), err
}

// Update takes the representation of a logTail and updates it. Returns the server's representation of the logTail, and an error, if there is any.
func (c *FakeLogTails) Update(ctx context.Context, logTail *v1alpha1.LogTail, opts v1.UpdateOptions) (result *v1alpha1.LogTail, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(logtailsResource, c.ns, logTail), &v1alpha1.LogTail{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LogTail), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeLogTails) UpdateStatus(ctx context.Context, logTail *v1alpha1.LogTail, opts v1.UpdateOptions) (*v1alpha1.LogTail, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(logtailsResource, "status", c.ns, logTail), &v1alpha1.LogTail{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LogTail), err
}

// Delete takes name of the logTail and deletes it. Returns an error if one occurs.
func (c *FakeLogTails) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(logtailsResource, c.ns, name), &v1alpha1.LogTail{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeLogTails) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(logtailsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.LogTailList{})
	return err
}

// Patch applies the patch and returns the patched logTail.
func (c *FakeLogTails) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.LogTail, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(logtailsResource, c.ns, name, pt, data, subresources...), &v1alpha1.LogTail{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LogTail), err
}
